<?php

namespace Picea\Ui\Method;

use Picea\Extension\Extension,
    Picea\Extension\ExtensionTrait;

use Picea\Compiler\Context;

use Psr\Http\Message\ServerRequestInterface;

class Pagination implements Extension {
    use ExtensionTrait;

    public array $tokens;

    public string $token;

    public ServerRequestInterface $request;
    
    public function __construct(ServerRequestInterface $request, Context $context) {
        $this->request = $request;
        $this->register($context);
    }

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) : string { }

    public function register(Context $context) : void
    {
        $context->pushFunction("pagination", [ $this, 'paginationClass' ]);
    }

    public function paginationClass(string $name, ?string $url = null, ?array $params = null) : PaginationHandler
    {
        return new PaginationHandler($this->request, $name, $url, $params);
    }
}
